Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0006656opensim[GRID] Hypergridpublic2013-06-04 02:412015-04-21 02:09
Reporteraiaustin 
Assigned To 
PrioritynormalSeverityfeatureReproducibilityalways
StatusnewResolutionopen 
PlatformPCOSWindowsOS Version8
Product Versionmaster (dev code) 
Target VersionFixed in Version 
Summary0006656: Uniformity of handling local and hypergrid teleportable links in Chat/IM and incorrect FROM grid addresses on HG TP
DescriptionThere are several cases where a teleport destination can be provided in chat or IM and which can be clicked to initiate a teleport without using the map or landmarks. This is very helpful in collaboration or when listing meeting destinations on web pages or via e-mail, group messages, notecards, etc.

For example, a link can be used this way to teleport on any grid EXCEPT OSGrid itself. On a grid itself the form with a HG grid address in it does not work. There the alternative local address has to be given.

For example if you type either of these into chat on any grid except OSGrid...

secondlife:///app/teleport/hg.osgrid.org:80:Lbsa%20Plaza [^]
hop:///app/teleport/hg.osgrid.org:80:Lbsa%20Plaza [^]

You get a nicely linked "Teleport to hg.osgrid.org:80:Lbsa Plaza" in chat, which if clicked takes you to the intended destination...

But if you type into chat a link like this to go back...

hop:///app/teleport/virtual.aiai.ed.ac.uk:8002:OpenVCE [^]

[02:35] Ai Austin: Teleport to virtual.aiai.ed.ac.uk:8002:OpenVCE
[02:35] Grid: Region found!
[02:36] Grid: Teleport completed from hop://virtual.aiai.ed.ac.uk:8002/Lbsa%20Plaza/129/124/38 [^]

Note the grid FROM is wrong.

hop:///app/teleport/hg.osgrid.org:80:Wright%20Plaza [^]

on OSGrid itself an error occurs "Cannot teleport to Null (0,0) from Lbsa Plaza (10402,10050)".. its not correctly interpreting the grid name and ignoring it if its on the same grid.


Steps To ReproduceJump to and from OSGrid and another grid using secondlife:/// [^] or hop:// style URLs with the grid name in them each time.

I don't think this is a viewer issue, but if it is I am happy to report it to the Firestorm viewer JIRA.

Additional InformationWhen I do move between grids the ARRIVAL message also mixes up the grid I am going TO and the grid I just came from...

ON OSGRIDS

ON Openvue Grid

[02:32] Ai Austin: Teleport to hg.osgrid.org:80:Lbsa Plaza
[02:32] Grid: Region found!
[02:32] Grid: Teleport completed from hop://virtual.aiai.ed.ac.uk:8002/OpenVCE/127/81/23 [^]

This shows the FROM location correctly, and hence works as a link in chat to go back.

[02:29] Grid: Region found!
[02:29] Grid: Teleport completed from hop://virtual.aiai.ed.ac.uk:8002/Lbsa%20Plaza/125/126/38 [^]
TagsNo tags attached.
Git Revision or version number22816
Run Mode Grid (Multiple Regions per Sim)
Physics EngineODE
Script Engine
EnvironmentMono / Windows
Mono VersionNone
ViewerFirestorm 4.4.0 OS
Attached Files

- Relationships

-  Notes
(0024016)
aiaustin (developer)
2013-06-07 04:06
edited on: 2013-06-07 04:07

Trying to pin some of the issues down... I have added some notes to a Firestorm Viewer JIRA issue...

Added some notes on issues with clickable teleport links for OpenSim in nearby chat and their formats at http://jira.phoenixviewer.com/browse/FIRE-7044#comment-113395 [^]

Included here in case we find the issues are OpenSim server and Hypergrid module related...

On Firestorm 4.4.0 OpenSim version I am trying nto work out what region ,ink issues are viewer elated and which might need server side code changes, especialy in the way Hypergrid links work.

On the Openvue grid which uses the very latest (r/22834 currently) OpenSim version there are a number of areas where links do not quite work as expected...

E.g. when you teleport from one location to another ON THE SAME grid the nearby chat shows the location you just came from in the form

Grid: Teleport completed from hop://virtual.aiai.ed.ac.uk:8002/OpenVCE/29/237/29 [^]

This is properly linked. But it cannot be clicked to go back as it says

Grid: No regions found with that name.

This style of link works on a FOREIGN grid and you can go back fine... but it needs THREE // and doe snot work with 2??

hop:///hg.osgrid.org:80:Wright [^] Plaza/

It brings up the map in this case but then works. THEN the return hop on the foreign grid does work.

ON Openvue grid...

[03:50] Grid: Teleport completed from hop://virtual.aiai.ed.ac.uk:8002/OpenVCE/29/237/29 [^]
[03:50] Grid: No regions found with that name.
[03:50] Grid: Teleport completed from hop://virtual.aiai.ed.ac.uk:8002/OpenVue/130/126/30 [^]
[03:50] Grid: No regions found with that name.


Moving from openvue to OSGrid and back - but note the grid name when returning incorrectly shows a return from Wright Plaza on virtual.aiai.ed.ac.uk:8002 (the hoke grid) and NOT the grid the teleport was really from which should be hg.osgrid.org:80

03:58] Ai Austin: hop:///hg.osgrid.org:80:Wright [^] Plaza/
[03:58] Grid: Region found!
[03:59] Grid: Teleport completed from hop://virtual.aiai.ed.ac.uk:8002/OpenVCE/129/126/23 [^]
[03:59] Grid: The region you have entered is running a different simulator version.
Current simulator: OpenSim 0.7.6 Dev ac9c37f: 2013-06-06 23:49:34 +0100 (Unix/Mono)
Previous simulator: OpenSim 0.7.6 Dev (Win/.NET)
[03:59] Grid: Region found!
[03:59] Grid: Teleport completed from hop://virtual.aiai.ed.ac.uk:8002/Wright%20Plaza/127/129/22 [^]
[03:59] Grid: The region you have entered is running a different simulator version.
Current simulator: OpenSim 0.7.6 Dev (Win/.NET)
Previous simulator: OpenSim 0.7.6 Dev ac9c37f: 2013-06-06 23:49:34 +0100 (Unix/Mono)

(0024025)
aiaustin (developer)
2013-06-07 13:14
edited on: 2013-06-07 14:36

At request of Cinders Biscuit of Firestorm Viewer development team, this has been reported at http://jira.phoenixviewer.com/browse/FIRE-10549 [^]

Please add information there to help get this improved... though some server side and Hypergrid URL issues on the server side might need attention.

I wonder if the space before a region name is a serious issue for handling in a wide range of contexts for example. A method to give a HG url without breaks may be best as that breaks the default hyperlinks handling in chat/IM, e-mailers, editors and other link editing tools. As noted by Jeff Kelley on opensim-users mailing list.

(0024026)
aiaustin (developer)
2013-06-07 15:35
edited on: 2013-06-07 15:58

Suggestion if this makes technical sense... that URLs of the following forms are made to work as legitimate clickable teleport and map destination on ANY grid including the local gridname.com:port

http://gridname.com:port/regionname/x/y/z [^]
secondlife://gridname.com:port/regionname/x/y/z [^]
  (for current viewer compatibility)
hop://gridname.com:port/regionname/x/y/z [^]
  (to allow for growth of the metaverse beyond SL)

if gridname:port not given only local grid is used.

If regionname is not given default region name for grid is used if reported.

Usual defaults assumed if x, y and/or z not given.

Unusual forms with two colons, multiple !!! and use of spaces before region smes in the URL not legitimately replaced by %20 code are all dropped.

(0024060)
aiaustin (developer)
2013-06-10 12:13

hop:// format notes... can we get behind this in the Hypergrid protocols and make them work everywhere?

Cinders Biscuits of the Firestorm Viewer development team comments to me in
http://jira.phoenixviewer.com/browse/FIRE-10549 [^]
....

It was introduced by Armin Weatherwax for Kokua and Firestorm over a year ago. I don't know the history of it, just the scheme. It can be registered with IANA when it's finalized, possibly for FS 4.4.6. It's more than just replacing trademarked syntax. I'll write something up about it from what I've gleaned from Armin's commits.

Bear in mind, this is not a Firestorm specific scheme. It originated in Kokua for adding grids to the gridlist from the web and grew and is present in all hypergrid enabled V2/V3-based viewers for OpenSim.
(0024066)
aiaustin (developer)
2013-06-11 02:37

Following noted here in case there are server side implications, but also reported on http://jira.phoenixviewer.com/browse/FIRE-10549 [^]

One things I have identified as a genuine Firestorm 4.4.0 bug rather than just a proposal to tidy this up is that when you hop between OpenSim grids the "Teleport completed from hop:// always states the HOME grid you originally logged in on.. and not the grid you actually teleported from.

To reproduce....
----------------------

Login as OSGrid avatar and currently on OSGrid OpenVCE region...

hop://virtual.aiai.ed.ac.uk:8002/Vue-9000/128/128/25/ [^]
[02:18] Grid: Region found!
[02:18] Grid: Teleport completed from hop://login.osgrid.org/OpenVCE/120/117/23 [^]

hop:// link correctly shows as clicable...

Now on Openvue grid (virtual.aiai.ed.ac.uk:8002) on Vue-9000 region...
 Click the return link above...

[02:18] Grid: Region found!
[02:18] Grid: Region found!
[02:18] Grid: Teleport completed from hop://login.osgrid.org/Vue-9000/128/128/26 [^]

Now the avatar is correctly back on OSGrid on OpenVCE region... but note that the return link now gives the wrong grid name. If you try to click it of course it says...

[02:23] Grid: No regions found with that name.

--------------------
hop:// handler does not handle case where local grid name is in URI

Also if a hop:// form link is put in chat that happens to include the HOME grid host name...e.g. if its sent to you via group communications to turn up at a location that happens to be on your home grid. The link is properly highlighted as clickable but if clicked the link not work. It would be best if the HOME grid allowed such links too even where the grid host given is the one you are on.

[02:28] Ai Austin: hop://login.osgrid.org/Vue-6400/120/117/23 [^]
[02:28] Grid: No regions found with that name.
[02:28] Ai Austin: hop://login.osgrid.org/OpenVCE/120/117/23 [^]
[02:28] Grid: No regions found with that name.

In these cases the map tool does pop up and if you click teleport there you get this message...

Teleport failed. Can't teleport to Null (0,0) from OpenVCE (6400,6399), destination is more than 4095 regions way

Note also the minor typo on that error message which says "way" rather than "away".
(0024067)
aiaustin (developer)
2013-06-11 02:42
edited on: 2013-06-11 03:46

The following links act as a simple test of hop:// handling by viewers between two OpenSimulator grids... where the fours regions involved are all within one hop of each other (within 4095,4095 regions on an x,y grid maps - another issue inherited from Second Life viewer specific restrictions). Hops ought to be possible between any of these URIs when they are used, you should get to the correct grid and the reported link to the previous place ought to work to return you to the grid and/or region you were in, even if teleporting between locations on the same grid.

hop://login.osgrid.org:80/Wright%20Plaza/128/128/25/ [^]
hop://login.osgrid.org:80/Sandbox%20Plaza/128/128/25/ [^]
hop://virtual.aiai.ed.ac.uk:8002/Vue-9000/128/128/25/ [^]
hop://virtual.aiai.ed.ac.uk:8002/Sandbox/128/128/25/ [^]

To test some viewers that are only set as helpers for the secondlife:// scheme these test links are also provided...

secondlife://login.osgrid.org:80/Wright%20Plaza/128/128/25/ [^]
secondlife://login.osgrid.org:80/Sandbox%20Plaza/128/128/25/ [^]
secondlife://virtual.aiai.ed.ac.uk:8002/Vue-9000/128/128/25/ [^]
secondlife://virtual.aiai.ed.ac.uk:8002/Sandbox/128/128/25/ [^]

(0024076)
aiaustin (developer)
2013-06-11 11:16

After I commented on the hops:// suggestion for hop secure with https://... [^]

Cinder Biscuits on the Firestorm JIRA reports - 11/Jun/13, 04:19 PM +0100
That's in the works, yes, but not available yet. I'll be standardizing hop:// and cleaning it up for the release after 4.4.1.
(0025772)
aiaustin (developer)
2014-04-13 06:29
edited on: 2014-04-13 06:31

Just a refresh on this item.. hop:// now work fairly well in most places you would expect on recent viewers like Firestorm 4.6.1

The following link gives a set of test hop:// links including some intended to test likely problematic cases, along with reports on what works in recent viewer versions (like location bar and chat/IM links except for same grid problems)and what does not yet work (in the map tool for example)...

     http://www.aiai.ed.ac.uk/~ai/hg.html [^]

Maybe some changes to OpenSim/Services/GridService/HypergridLinker.cs to add a part for hop:// handling there will resolve the lack of hop:// handling in the map.

Some means to ignore the grid element when it matches the local grid would also allow links to work intra-grid as well as inter-grid.

(0026411)
JeffKelley (reporter)
2014-06-28 09:48

I don't see this as an OpenSim issue but a viewers issue. This is an interface between the viewer and the rest of the operating system. It does not concern OpenSim. So, the choice of the format is not constrained by OpenSim and can be anything we decide. It's a matter of passing a message from an app to another, the said message comprising : a domain name; a region name; a coordinate vector. An URI scheme (seconflife::// or hop://) acts as an identifier to the target application but is not part of the message. Note that secondlife:// is already registered at IANA while hop:// is not.

Since uniformity is desired, it should be implemented into each and every viewer, not only in Firestorm. That means it has to be handled at a higher level. An IETF RFC would be a good place in my mind. Since uniformity is desired, it should also be recognized by any textedit engine, thus comply with RFC 3986 "Uniform Resource Identifier Generic Syntax". This is essential if you want your mailer, web browser, messenger to parse it.
(0026651)
aiaustin (developer)
2014-07-31 14:54
edited on: 2014-07-31 14:55

Cinder Biscuits comments in

http://jira.phoenixviewer.com/browse/FIRE-10549 [^]

that the hop://grid:port/region/x/y/z [^] placed in local chat in viewers comes from the SIMULATOR. the grid:port given is always the avatar's home grid at login and does not reflect the alst grid the avatar was on, so cannot be used for click to return... can the simulator correct this?

Ai Austin noted on Firestorm JIRA on 31-Jul-2014

Just a little "ping" on the remaining issues with handling of the hop:// protocol... inserting the correct and current grid in the previous location hop:// links inserted into nearby chat, rather than incorrectly using the initial home login grid always would make this much more usable.

Cinder Biscuits added a comment on 31-Jul-2014

The simulator sends that message back to the viewer when you finish a teleport. It has no idea what grid you're coming from. It would take a considerable amount of effort to refactor the teleport complete slurl because you would have to, in essence, override what the simulator is sending. Teleport history has the correct location as well as the forward and back buttons in the upper left hand corner.

(0026653)
aiaustin (developer)
2014-08-01 10:17

I wonder if the new [SimulatorExtraFeatures] or [GridExtraFeatures] section values do, or can, relate to a way to fix this?
(0028041)
aiaustin (developer)
2015-04-21 02:09

Just to note, as reported today in

http://jira.phoenixviewer.com/browse/FIRE-10549 [^]

that Firestorm 4.7.1 (45301 PreviewX64) tested on OpenSim grids for hop:// link handling behaves the same as the current released Firestorm.

Test notes and sample hop:// links for testing are at
http://www.aiai.ed.ac.uk/~ai/hg.html#FS4.7.1 [^]

It would be nice if it was possible to fix the grid in a hop:// to always reflect the current grid you are on rather than always incorrectly using the original login (home) grid. The viewer must know the grid it has gone to (via a teleport) even if the OpenSim grid is not providing that information in a form useful to the viewer. But if necessary some way to work with the OpenSim devs to add what is needed would be good too.

- Issue History
Date Modified Username Field Change
2013-06-04 02:41 aiaustin New Issue
2013-06-07 04:06 aiaustin Note Added: 0024016
2013-06-07 04:07 aiaustin Note Edited: 0024016 View Revisions
2013-06-07 13:14 aiaustin Note Added: 0024025
2013-06-07 13:14 aiaustin Note Edited: 0024025 View Revisions
2013-06-07 13:14 aiaustin Note Edited: 0024025 View Revisions
2013-06-07 14:36 aiaustin Note Edited: 0024025 View Revisions
2013-06-07 15:35 aiaustin Note Added: 0024026
2013-06-07 15:36 aiaustin Note Edited: 0024026 View Revisions
2013-06-07 15:53 aiaustin Note Edited: 0024026 View Revisions
2013-06-07 15:55 aiaustin Note Edited: 0024026 View Revisions
2013-06-07 15:56 aiaustin Note Edited: 0024026 View Revisions
2013-06-07 15:58 aiaustin Note Edited: 0024026 View Revisions
2013-06-10 12:13 aiaustin Note Added: 0024060
2013-06-11 02:37 aiaustin Note Added: 0024066
2013-06-11 02:42 aiaustin Note Added: 0024067
2013-06-11 02:43 aiaustin Note Edited: 0024067 View Revisions
2013-06-11 02:45 aiaustin Note Edited: 0024067 View Revisions
2013-06-11 03:22 aiaustin Note Edited: 0024067 View Revisions
2013-06-11 03:46 aiaustin Note Edited: 0024067 View Revisions
2013-06-11 11:16 aiaustin Note Added: 0024076
2014-04-13 06:29 aiaustin Note Added: 0025772
2014-04-13 06:31 aiaustin Note Edited: 0025772 View Revisions
2014-04-13 06:31 aiaustin Note Edited: 0025772 View Revisions
2014-06-28 09:48 JeffKelley Note Added: 0026411
2014-07-31 14:54 aiaustin Note Added: 0026651
2014-07-31 14:54 aiaustin Note Edited: 0026651 View Revisions
2014-07-31 14:55 aiaustin Note Edited: 0026651 View Revisions
2014-08-01 10:17 aiaustin Note Added: 0026653
2015-04-21 02:09 aiaustin Note Added: 0028041


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker